const User = require("./classes/userClass")

config = require("../config")

worldObj = require("./storageObjects/worldObj")
userObj = require("./storageObjects/userObj")
messageObj = require("./storageObjects/messagesObj")
creaturesObj = require("./storageObjects/creatureObj")
creatureArr = require("./storageObjects/creatureArr")
svg = require("../webServer/gameSVG")
mongo = require("./mongoHelp")
Creature = require("./classes/creatureClass")





function setupGame(){
  return new Promise((resolve,reject) => {
    messageObj.wipe()
    creaturesObj = {}
    creatureArr = []
    worldObj.clean()
    setTimeout(() => {
      numCreatures = 0
      Object.keys(userObj).forEach((user) => {
        if(userObj[user]["readyState"] == true){
          numCreatures += config.genesisCreaturesPerUser
        }
      })
      console.log("Spawning "+numCreatures+" creatures")
      for (let index = 0; index < numCreatures; index++) {
        creatureArr.push(new Creature())
      }
    }, config.timers.preGame*0.75)
    setTimeout(() => {

      if (creatureArr.length == 0){
        return reject(false)
      } else {
        svg.setup()
        return resolve(true)
      }
    }, config.timers.preGame);
  })
}



function gameLoop(){
  return new Promise((resolve,reject) => {
    loop = setInterval(() => {
      deadCreatureCount = 0
      creatureArr.forEach((creature, index) => {
        creature.act()
        if (!creature.alive){
          deadCreatureCount +=1
          creatureArr.splice(index,1)
        }
      })
      // messageObj.print("Death")
      // messageObj.print("Birth")
      // messageObj.print("Location")
      console.log("Dead: "+deadCreatureCount)
      console.log("World: "+worldObj.id+" "+worldObj.universe+" "+worldObj.step)
      console.log("Creatures: "+creatureArr.length)
      console.log(new Date)
      messageObj.wipe()
      if (creatureArr.length == 0){
        console.log("All Dead")
        Object.keys(userObj).forEach(user => {
          userObj[user].clean()
        })
        clearInterval(loop)
        return resolve(true)
      } else {
        console.log(creatureArr[0].fullName, creatureArr[0].location,creatureArr[0].energy+"/"+creatureArr[0].maxEnergy, creatureArr[0].age+"/"+creatureArr[0].maxAge, creatureArr[0].generation,creatureArr[0].births,creatureArr[0].kills)
      }
      worldObj.step += 1
      svg.make()
    }, config.timers.gameStep)
  })
}

function gifGen(){
  return new Promise((resolve,reject) => {
    
  })
}

function recurse(){
  setupGame().then(() => {
    gameLoop().then(()=> {
      // process.exit()
      recurse()
      // gifGen.then(() =>{
      //   
      // })
    })
  }).catch(issue => {
    setTimeout(() => {
      recurse()
    }, config.timers.preGame);
  })
}

mongo.get("algoZoo", "users", {readyState: true}).then(userArr => {
  userArr.forEach(user => {
    new User(user.name, user.pass,user._id, user.energy, user.powers)
  })
  recurse()
})
