config = require("../../config")
const { v4: uuidv4 } = require('uuid')

svg = require("../../webServer/gameSVG")
userObj = require("../storageObjects/userObj")


worldObj = {
  tiles: {},
  id: uuidv4(),
  step: 0,
  universe: 0,
  // stop stringifying outside, do it in you bad one
  makeTile:(stringifiedArr) => {
    if (stringifiedArr === undefined){
      return 0
    }
    
    if (typeof worldObj.tiles[JSON.stringify(stringifiedArr)] == "undefined" || Object.keys(worldObj.tiles[JSON.stringify(stringifiedArr)]).length == 0){
      worldObj.tiles[stringifiedArr] = {
        creature: {},
        foodLevel: config.world.tileDefaultFood,
      }
    }
    return 100
  },
  checkBlocked: (arr) => {

    if (arr === undefined){
      return true
    }
    if (worldObj.checkCreature(arr)){
      return true
    } else {
      return false
    }
  },
  checkCreature: (arr) => {
    if (!worldObj.tiles[JSON.stringify(arr)]){
      worldObj.makeTile(JSON.stringify(arr))
    }
    
    if (typeof worldObj.tiles[JSON.stringify(arr)].creature.fullName == "undefined"){
      return false
    } else {
      return worldObj.tiles[JSON.stringify(arr)].creature.fullName
    }
  },
  checkTileFoodLevel: (arr)=> {
    if (!worldObj.tiles[JSON.stringify(arr)]){
      worldObj.makeTile(JSON.stringify(arr))
    }
    return worldObj.tiles[JSON.stringify(arr)].foodLevel
  },  
  clean: () => {
    delete worldObj.tiles
    delete worldObj.id
    worldObj.id = uuidv4()
    worldObj.tiles = {}
    worldObj.universe += 1
    worldObj.step = 0 
  }
}
module.exports = worldObj