config  = require("../config")
creatureArr = require("../game/storageObjects/creatureArr")
worldObj = require("../game/storageObjects/worldObj")
var svg = require('svg-builder')
fs = require('fs')
const path = require('path');
svg.width("100%")
svg.height("100%")
svg.viewBox("0 0 "+config.boundry.top+" "+config.boundry.right)

var rgb2hex = require('rgb2hex')

gameImage = {
  setup: () =>{
    console.log("setup",worldObj.id)
    fs.mkdir(path.join(__dirname +"/mapImages/tmp/", worldObj.id), (err) => {
      if (err) {
          return console.error(err);
      }
      console.log('Directory created successfully!')
  })
  },
  make:() => {
    svg.reset()
    creatureArr.forEach((creature,index) => {
      if (typeof creature.location != "undefined" && creature.location[0] != null  && typeof creature.colour != "string"){
        colour = creature.colour
        svg.circle({
          r: 1,
          fill: rgb2hex('rgb('+colour[0]+','+colour[1]+','+colour[2]+')').hex,
          stroke: rgb2hex('rgb('+colour[0]+','+colour[1]+','+colour[2]+')').hex,
          cx: creature.location[0],
          cy: creature.location[1]
      }).text({
        x: creature.location[0],
        y: creature.location[1],
        'font-family': 'helvetica',
        'font-size': 0.1,
        stroke : '#000',
        fill: '#fff'
    }, creature.owner[0])
      }
    })
    gameImage.image = svg.render()
    fs.writeFile(__dirname +"/mapImages/tmp/"+worldObj.id+"/"+worldObj.step+".svg", gameImage.image, function (err) {
      if (err) return console.log(err)
    })
  },
  image: ""
}

module.exports = gameImage